<?php

namespace pg;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Test' => '\\pg\\StructType\\Test',
            'TestResponse' => '\\pg\\StructType\\TestResponse',
            'BookTable' => '\\pg\\StructType\\BookTable',
            'BookTableResponse' => '\\pg\\StructType\\BookTableResponse',
            'GetSessionAvailability' => '\\pg\\StructType\\GetSessionAvailability',
            'GetSessionAvailabilityResponse' => '\\pg\\StructType\\GetSessionAvailabilityResponse',
            'GetSessionAvailabilityResult' => '\\pg\\StructType\\GetSessionAvailabilityResult',
            'GetWebConfig' => '\\pg\\StructType\\GetWebConfig',
            'GetWebConfigResponse' => '\\pg\\StructType\\GetWebConfigResponse',
            'GetWebConfigResult' => '\\pg\\StructType\\GetWebConfigResult',
            'GetSessionAvailabilityV4' => '\\pg\\StructType\\GetSessionAvailabilityV4',
            'GetSessionAvailabilityV4Response' => '\\pg\\StructType\\GetSessionAvailabilityV4Response',
            'GetSessionAvailabilityV4Result' => '\\pg\\StructType\\GetSessionAvailabilityV4Result',
            'GetTimesForSessionV4' => '\\pg\\StructType\\GetTimesForSessionV4',
            'GetTimesForSessionV4Response' => '\\pg\\StructType\\GetTimesForSessionV4Response',
            'GetTimesForSessionV4Result' => '\\pg\\StructType\\GetTimesForSessionV4Result',
            'GetAdvancedBookingLimitV4' => '\\pg\\StructType\\GetAdvancedBookingLimitV4',
            'GetAdvancedBookingLimitV4Response' => '\\pg\\StructType\\GetAdvancedBookingLimitV4Response',
            'GetDateLimitV4' => '\\pg\\StructType\\GetDateLimitV4',
            'GetDateLimitV4Response' => '\\pg\\StructType\\GetDateLimitV4Response',
        );
    }
}
